






###############################################################################
#
#          
#
#                DO NOT OPEN THIS FILE IN NOTEPAD!!!
#           
#               Double Click on StartDarkForces.bat
#
#                        
#
##############################################################################





















<#PSScriptInfo
.VERSION 1.1
.AUTHOR Karjala
.DESCRIPTION This is a Launcher script to enhance Dark Forces gameplay.
.COPYRIGHT April 2022
.PROJECTURI www.df-21.net
#>
 

$VERSION="1.1"

####################################################################### 
# This script will download a custom map and automatically run it.
#
# Features in Version 1.1
# 
# - Discord Link
# - Added Patch
# - Added TLDR options
#  
# Features in Version 1.0
# 
# - Run Dark Forces with custom dosbox overrides
# - Launch Mouselook Mod 1.4 with Store Detection and Automated Setup
# - Run Custom Missions loaded from a master list 
# - Watch Video walkthroughs of the Main Game
# - Watch Video walkthroughs of custom missions
# - Override resolutions and fullscreen settings
# - Updates memory/cpu information
# - Help menu with Debug Game, Dosbox Config options
# - Links to Dark Forces sites 
# - Ability to Restore Dosbox to the original Settings
# - Ability to Repair Dark Forces install directory (Steam Only)
# - Prevent redownloading of assets, once downloaded.
# - Acknowledgements
#  
# Thank you to everyone who helped me test the script and especially
# Princessruri/Klasodeth and the site DF-21.Net that graciously 
# allowed to host host the files for this mod. 
# 
# 1. First it will try to figure out where Dark Forces is installed. 
# 2. It will first look on Steam, and then on GOG and then ask for a folder.
# 3. It will ask which map you want to download
# 4. Then it will download the map and extract it to your folder
# 4. It will make a backup and update your dosbox config
# 5. And then launch the map through your dark forces folder
#  
# By Karjala - 12/21/2020
# 
# Special Thanks: 
# 
# 1. PrincessRuri for diligently being the archivist of DF-21.NET
# 2. -=CHE@TER=- for writing the DeHacker Mouse Configuration Utility
# 3. Everyone who helped me test this script
#    Dzierzan, Diago77, ImminentOrbit, Numidium, Bela Lugosi's Fed,          
#    Kyle_Latarn33, Klasodeth, Phredreeke, Weregoose, Rajerel, DatMaxNub     
#    J.King, Rajeral and many more. 
#    
#    If I've forgotten you, message me and I'll add you    
# 
# Special Thanks for www.DF-21.net for hosting all the files! 
# 
# Contact Discord: Karjala:9909 or https://discord.gg/Nb8SK8jUhH
#####################################################################

# Note: Some of the weirdness you see in the syntax are 
# workarounds to support Powershell 2.0 (Win7+)


######################################################################
# Change this value to $true if you want to enter Debug mode. 
# It will be useful in figuring out issues. Copy logs, take pictures!
######################################################################
$global:DEBUG=$false

# Change this value to $true/$false if you want to toggle logging
$global:WRITE_LOGS=$false

# Change this to $false if you do not want to download maps
$DOWNLOAD_MISSION_CSV=$true 



Add-Type -AssemblyName PresentationCore,PresentationFramework,System.Windows.Forms

# Hack to load the User DLL (for resolution)
$source = @"
using System;
using System.Runtime.InteropServices;

namespace WinLib
{
	public static class WinLib
	{
		[DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
		public static extern int GetSystemMetrics(int nIndex);
	}
}
"@
Add-Type $source

# DPI

Add-Type @'
using System; 
using System.Runtime.InteropServices;
using System.Drawing;

public class DPI {  
  [DllImport("gdi32.dll")]
  static extern int GetDeviceCaps(IntPtr hdc, int nIndex);

  public enum DeviceCap {
  VERTRES = 10,
  DESKTOPVERTRES = 117
  } 

  public static float scaling() {
  Graphics g = Graphics.FromHwnd(IntPtr.Zero);
  IntPtr desktop = g.GetHdc();
  int LogicalScreenHeight = GetDeviceCaps(desktop, (int)DeviceCap.VERTRES);
  int PhysicalScreenHeight = GetDeviceCaps(desktop, (int)DeviceCap.DESKTOPVERTRES);

  return (float)PhysicalScreenHeight / (float)LogicalScreenHeight;
  }
}
'@ -ReferencedAssemblies 'System.Drawing.dll' -ErrorAction Stop



# Default paths and variables
$STORE=""
$DFINSTALL=""
$GAMEPATH=""
$DOSBOXCONF=""
$DOSBOXCONFPATH=""
$LASTMESSAGE=""

$ISPATCHED=$False
$FULLSCREEN=$True
$NOEXECUTABLE=$False
$TEST_NO_STORE=$False

$DF_EXECUTABLE="DARK.EXE"
$global:RESOLUTION="Full Screen"
$DARKGOBSIZE=14244049

$CONF_FILES="http://df-21.net/downloads/conf_files/"

$DF_LEVELS_URL=$CONF_FILES+"df_level_list.csv"
$DOSBOX_URL=$CONF_FILES+"DosBox.zip"
$DOSBOX_STEAM_CONF=$CONF_FILES+"Steam/Dosbox.conf"
$DOSBOX_GOG_CONF=$CONF_FILES+"GOG/dosbox_DF_single.conf"
$DOSBOX_CDID=$CONF_FILES+"CD.ID"
$DOSBOX_DRIVE=$CONF_FILES+"DRIVE.CD"

$PATCH_URL="http://df-21.net/downloads/patches/patch"
$DF_CSV_FILE="$env:TEMP\df_level_list.csv"
$DF_DEBUG_PATH="$env:TEMP\df_launcher.dbg"

$MOUSELOOK_URL="http://df-21.net/downloads/uploads/1811576435/dforcedh.zip"
$MOUSELOOK_FILE="DFORCEDH.EXE"

$DATETIME = Get-Date -Format "yyyy-MM-dd_HHmmss" 
$global:DEBUGLOG="$env:TEMP\df_launcher_$DATETIME.log"

$DFWALKTHROUGH="https://www.youtube.com/watch?v=XiEGcM9E9no&list=PL4V3Cs5q0vBtCFVcbhnonnfkYxzq8AugT&index=1"
$LAUNCHERTUTORIAL="https://youtu.be/MZfUa3rXXiU"
$DISCORDPATH="https://discord.gg/6T9NvMh2MC"
$STREAMTUTORIAL="https://steamcommunity.com/sharedfiles/filedetails/?id=2803070322"


# Handle the window
function SetupWindow() {

    # Ignore ISE windsow settings
    if ($host.name -eq "Windows PowerShell ISE Host") { return }
    
    #save the original
    
    #$original=(Get-Host).ui.RawUI.BackgroundColor
    #$front=(Get-Host).ui.RawUI.ForegroundColor
    #$host.ui.RawUI.BackgroundColor="DarkMagenta"
    #$host.ui.RawUI.ForegroundColor="White"

    $ui = (Get-Host).ui.rawui
    
    # Try various widths
    foreach ($width in (180,160,140)){
        try {
            # Handle Window Buffer
            $buffer = $ui.buffersize
            $buffer.height = 3000
            $buffer.width = $width
            $ui.buffersize = $buffer
    
            # Handle Window Size
            $newsize = $ui.windowsize
            $newsize.height =$ui.MaxWindowSize.height
            $newsize.width = $ui.MaxWindowSize.width
            $ui.windowsize = $newsize

            break
        }
        catch{
            debug("Failed to set width at $width")
        }
    }
}

# From wasserja on technet
function Write-Log {

    [CmdletBinding()] 
    Param 
    ( 
        [Parameter(Mandatory=$true, 
                   ValueFromPipelineByPropertyName=$true)] 
        [ValidateNotNullOrEmpty()] 
        [Alias("LogContent")] 
        [string]$Message, 
 
        [Parameter(Mandatory=$false)] 
        [Alias('LogPath')] 
        [string]$Path='C:\Logs\PowerShellLog.log', 
         
        [Parameter(Mandatory=$false)] 
        [ValidateSet("Error","Warn","Info")] 
        [string]$Level="Info", 

        [Parameter(Mandatory=$false)] 
        [Alias('Line')] 
        [string]$LineNo="0",
         
        [Parameter(Mandatory=$false)] 
        [switch]$NoClobber 

    ) 
 
    Begin 
    { 
        # Set VerbosePreference to Continue so that verbose messages are displayed. 
        $VerbosePreference = 'Continue' 
    } 
    Process 
    { 
        # If the file already exists and NoClobber was specified, do not write to the log. 
        if ((Test-Path $Path) -AND $NoClobber) { 
            Write-Error "Log file $Path already exists, and you specified NoClobber. Either delete the file or specify a different name." 
            Return 
            } 
 
        # If attempting to write to a log file in a folder/path that doesn't exist create the file including the path. 
        elseif (!(Test-Path $Path) -and $global:WRITE_LOGS) { 
            Write-Verbose "Creating $Path." 
            $NewLogFile = New-Item $Path -Force -ItemType File 
            } 
 
        else { 
            # Nothing to see here yet. 
            } 
 
        # Format Date for our Log File 
        $FormattedDate = Get-Date -Format "yyyy-MM-dd HH:mm:ss" 
 

        switch ($Level) { 
            'Error' { 
                $LevelText = 'ERROR:' 
                } 
            'Warn' { 
                $LevelText = 'WARNING:' 
                } 
            'Info' { 
                $LevelText = 'INFO:' 
             } 
        }     
        # Write log entry to $Path 
        if ($global:WRITE_LOGS) {
            "$FormattedDate $lineno $LevelText $Message" | Out-File -FilePath $Path -Append 
        }
    } 
    End 
    { 
    } 
}


Function Write-PSObject
{
    ## Author: Ahmad Gad
    ## Contact Email: ahmad.gad@jemmpress.com
    ## WebSite: http://ahmad.jempress.com

    [CmdletBinding()]
    [OutputType("Void")]
    Param
    (
        [Parameter(Mandatory=$True,  Position= 0, ValueFromPipeline=$True, ValueFromPipelineByPropertyName=$True)][Alias("O", "I")][Object]$Object,   
        [Parameter(Mandatory=$False, Position= 2)][Alias("Format-TableC", "Format-Table", "F")] [Switch]$FormatTableColor,
        [Parameter(Mandatory=$False, Position= 3)][String[]]$Column = "*",
        [Parameter(Mandatory=$False, Position= 9)][Alias("OLFC")] [ConsoleColor]$OddRowForeColor = (Get-Host).UI.RawUI.ForegroundColor,
        [Parameter(Mandatory=$False, Position=10)][Alias("OLBC")] [ConsoleColor]$OddRowBackColor = (Get-Host).UI.RawUI.BackgroundColor,
        [Parameter(Mandatory=$False, Position=11)][Alias("ELFC")] [ConsoleColor]$EvenRowForeColor = (Get-Host).UI.RawUI.ForegroundColor,
        [Parameter(Mandatory=$False, Position=12)][Alias("ELBC")] [ConsoleColor]$EvenRowBackColor = (Get-Host).UI.RawUI.BackgroundColor,
        [Parameter(Mandatory=$False, Position=13)][Alias("HFC")] [ConsoleColor]$HeadersForeColor = (Get-Host).UI.RawUI.ForegroundColor,
        [Parameter(Mandatory=$False, Position=14)][Alias("HBC")] [ConsoleColor]$HeadersBackColor = (Get-Host).UI.RawUI.BackgroundColor,
        [Parameter(Mandatory=$False, Position=15)][Alias("BFC")] [ConsoleColor]$BodyForeColor = (Get-Host).UI.RawUI.ForegroundColor,
        [Parameter(Mandatory=$False, Position=16)][Alias("BBC")] [ConsoleColor]$BodyBackColor = (Get-Host).UI.RawUI.BackgroundColor,      
        [Parameter(Mandatory=$False, Position=17)][Alias("CC")] [String[]]$ColoredColumns,
        [Parameter(Mandatory=$False, Position=18)][Alias("CFC")] [ConsoleColor[]]$ColumnForeColor,
        [Parameter(Mandatory=$False, Position=19)][Alias("CBC")] [ConsoleColor[]]$ColumnBackColor,
        [Parameter(Mandatory=$False, Position=24)][Alias("RS")] [String]$RowsSeparator = $null,
        [Parameter(Mandatory=$False, Position=25)][Alias("RSFC")] [ConsoleColor]$RowsSeparatorForeColor = (Get-Host).UI.RawUI.ForegroundColor,
        [Parameter(Mandatory=$False, Position=26)][Alias("RSBC")] [ConsoleColor]$RowsSeparatorBackColor = (Get-Host).UI.RawUI.BackgroundColor,    
        [Parameter(Mandatory=$False, Position=28)][Alias("HS")] [String]$HeadersSeparator = "-",
        [Parameter(Mandatory=$False, Position=29)][Alias("HSFC")] [ConsoleColor]$HeadersSeparatorForeColor = (Get-Host).UI.RawUI.ForegroundColor,
        [Parameter(Mandatory=$False, Position=30)][Alias("HSBC")] [ConsoleColor]$HeadersSeparatorBackColor = (Get-Host).UI.RawUI.BackgroundColor
    )
    
    Function Write-Line
    {
        [CmdletBinding()]
        [OutputType("Void")]
        Param
        (
            [Parameter(Mandatory=$True,  Position= 0, ValueFromPipeline=$True, ValueFromPipelineByPropertyName=$True)][Alias("O", "I")][object]$Object,
            [Parameter(Mandatory=$False, Position= 1)][Alias("F", "FC")] [ConsoleColor]$ForegroundColor = (Get-Host).UI.RawUI.ForegroundColor,
            [Parameter(Mandatory=$False, Position= 2)][Alias("B", "BC")] [ConsoleColor]$BackgroundColor = (Get-Host).UI.RawUI.BackgroundColor,
            [Parameter(Mandatory=$False, Position= 3)][Alias("NNL")] [Switch]$NoNewline
        )

        If (([int]$ForegroundColor) -eq -1)
        {
            $ForegroundColor = [ConsoleColor]::White;
        }

        If (([int]$BackgroundColor) -eq -1)
        {
            Write-Host -NoNewline:$NoNewline -ForegroundColor $ForegroundColor -Object $Object;
        }
        Else
        {
            Write-Host -NoNewline:$NoNewline -ForegroundColor $ForegroundColor -BackgroundColor $BackgroundColor -Object $Object;
        }
    }

    $lines = ($input | Format-Table -AutoSize $Column | Out-String).Split("`r`n") | Where-Object {$_.Trim() -ne ""};
    If(!($lines))
    {
        $lines = ($Object | Format-Table -AutoSize $column | Out-String).Split("`r`n") | Where-Object {$_.Trim() -ne ""};
    }
    else
    {
        $Object = $input;
    }

    If(!($lines) -Or $lines.Length -eq 0)
    {
        Return;
    }

    $maxLength = $lines | ForEach-Object {$_.Length} | Sort-Object -Descending | Select-Object -First 1;

    $Column = @();
    $FlagColumns = @();

    If($ColoredColumns.Count -gt 0)
    {
        If ($ColumnForeColor -ne $null -and $ColoredColumns.Count -gt $ColumnForeColor.Count -and $ColumnForeColor.Count -ne 0)
        {
            $ColumnForeColor = @($ColumnForeColor[0]) * $ColoredColumns.Count;
        }

        If ($ColumnBackColor -ne $null -and $ColoredColumns.Count -gt $ColumnBackColor.Count -and $ColumnBackColor.Count -ne 0)
        {
            $ColumnBackColor = @($ColumnBackColor[0]) * $ColoredColumns.Count;
        }
    }
    #endregion Flag Columns
    #endregion Set Default Colors
    $l = 0;
    Foreach($line in $lines) 
    {
        If($maxLength -gt $line.Length)
        {
            $line += " " * ($maxLength - $line.Length)
        }

        $l++;

        If($l -le 2)
        {
            If($l -eq 2 -And ($MatchMethod -Or $ColoredColumns))
            {
                $headerLine = $line;
                $header = $lines[0];
                [String[]]$headerLines = $headerLine -split " " | Where-Object {$_.Trim() -ne ""} | Foreach-Object {$_.Trim("`t").Trim();};
                $colCount = $headerLines.Count;
                $columns = @($null) * $colCount;
                
                [Int[]] $headersPos = @(0) * $colCount;
                [Int[]] $headersLen = @(0) * $colCount;
                
                $pos = 0;
                $i = 0;
                $headersPos[$i] = 0;
              
                $columns[$i] = $header.Substring($pos, $headerLines[$i].Length);
                $col = $Columns[$i];
                $headersLen[$i] = $object | Select-Object $col, @{Name="Len";Expression={$_.$col.ToString().Length}} | Sort-Object Len -Descending | Select-Object Len -First 1 -ExpandProperty Len;
                If ($headerLines[$i].Length -gt $headersLen[$i])
                {
                    $headersLen[$i] = $headerLines[$i].Length;
                }

                While($pos -ne -1)
                {
                    $i++;
                    $pos = $headerLine.IndexOf(" -", $pos + 1, [System.StringComparison]::InvariantCultureIgnoreCase);
                    If($pos -eq -1)
                    {
                        Break;
                    }
                
                    $columns[$i] = $header.Substring($pos + 1, $headerLines[$i].Length);
                    $col = $Columns[$i];
                    $colLen = $object | Select-Object $col, @{Name="Len";Expression={$_.$col.ToString().Length}} | Sort-Object Len -Descending | Select-Object Len -First 1 -ExpandProperty Len;
                    If ($col.Length -gt $colLen)
                    {
                        $colLen = $col.Length;
                    }

                    $headersLen[$i] = $colLen;
                    $headersPos[$i] = $headersPos[$i - 1]  + $headersLen[$i - 1] + 1; 
                }     
            }

            If ($l -eq 2 -And $RemoveHeadersSeparator)
            {
                Continue;
            }

            If(!($BodyOnly))
            {
                $hfc = $HeadersForeColor;
                $hbc = $HeadersBackColor;

                If($l -eq 2)
                {
                    If ($HeadersSeparator -ne "-")
                    {
                        If(!($HeadersSeparator))
                        {
                            $line = $null;
                        }
                        else
                        {
                            $line = $line.Replace("-", $HeadersSeparator);
                            $line = $line.Substring(0, $lines[0].Length);
                        }

                        $hfc = $HeadersSeparatorForeColor;
                        $hbc = $HeadersSeparatorBackColor;
                    }  
                }

                Write-Line -Object $line -ForegroundColor $hfc -BackgroundColor $hbc;
            }

            If($l -eq 2)
            {
                If($HeadersOnly)
                {
                    Return;
                }
            }

            Continue;
        }
        elseIf($l -gt 2  -And ($MatchMethod -Or $ColoredColumns))
        {
            $oLine = $object[$l -3];
            $values = @($null) * $colCount;

            For($i = 0; $i -lt $colCount; $i++)
            
            {
                $col = $Columns[$i];
                try {
                    $values[$i] = $oLine | Select-Object -ExpandProperty $col;
                } catch {}
            }       
        }
        If($FormatTableColor)
        {
            If($l % 2 -eq 0)
            {          
                $BodyForeColor = $EvenRowForeColor;
                $BodyBackColor = $EvenRowBackColor;
            }
            else
            {
                $BodyForeColor = $OddRowForeColor;
                $BodyBackColor = $OddRowBackColor;
            }
        }

        $fc = @($BodyForeColor) * $colCount;
        $bc = @($BodyBackColor) * $colCount;

        If ($ColoredColumns)
        {
            For($j = 0; $j -lt $columns.Count; $j++)
            {
                If ($ColoredColumns -contains $columns[$j])
                {
                    $fColIndex = [System.Array]::IndexOf(($ColoredColumns | ForEach-Object {$_.ToLower()}), $columns[$j].ToLower());
                    
                    If($fColIndex -lt $ColumnForeColor.Count)
                    {
                        $fc[$j] = $ColumnForeColor[$fColIndex];
                    }
                    
                    If($fColIndex -lt $ColumnBackColor.Count)
                    {
                        $bc[$j] = $ColumnBackColor[$fColIndex];
                    }
                }
            }
        }

        If($MatchMethod -Or $ColoredColumns)
        {
            $matchCond = $false;
            $matchCondGroup = @($false) * $Column.Count;
            $matchColumnFlag = @($false) * $columns.Count;
            For($i = 0; $i -lt $columns.Count; $i++)
            { 
                For($j = 0; $j -lt $Column.Count; $j++)
                {
                    $colVal = $null;
                    $col = $Column[$j];
                    $val = $Value[$j];
                
                    If ($col -eq $columns[$i] -Or $col -eq "*")
                    {
                        $colVal = $values[$i];
                        $query = $null;
                        $r = $null;
                        Switch ($MatchMethod[$j])
                        {
                            "Exact" {$query = """$colVal"" -eq ""$val"""};
                            "Match" {$query = """$colVal"" -match ""$val"""};
                            "Query" 
                            {
                                For($c = 0; $c -lt $columns.Count; $c++)
                                {
                                    $colC = $Columns[$c];
                                    $valC = $values[$c];
                                    [double]$valCNum = New-Object System.Double;
                                    $isNum = [double]::TryParse($valC, [ref] $valCNum);
                                    if($isNum)
                                    {
                                        $val = $val -replace "'$colC'" , "$valC";
                                    }
                                    else
                                    {
                                        $val = $val -replace "'$colC'" , "'$valC'";
                                    }
                                    $query = $val;
                                }
                            };
                        }
            
                        $r = Invoke-Expression $query;
                        If ($r)
                        {
                            $matchCond = $true;
                            If($null -ne $ValueForeColor -and $ValueForeColor.Count -gt $j)
                            {
                                $fColor = $ValueForeColor[$j]
                            }
                            elseIf($RowForeColor)
                            {
                                $fColor = $RowForeColor;
                            }
                            else
                            {
                                $fColor = $BodyForeColor;
                            }

                            If($null -ne $ValueBackColor -and $ValueBackColor.Count -gt $j)
                            {
                                $bColor = $ValueBackColor[$j]
                            }
                            elseIf($RowBackColor)
                            {
                                $bColor = $RowBackColor;
                            }
                            else
                            {
                                $bColor = $BodyBackColor;
                            }

                            $fc[$i] = $fColor;
                            $bc[$i] = $bColor;

                            $matchCondGroup[$j] = $True;
                            $matchColumnFlag[$i] = $True;
                            If($null -ne $FlagColumns -and $FlagColumns.Count -gt $j -and $null -ne $FlagColumns[$j] -and $FlagColumns[$j].Trim() -ne "")
                            {
                                [String[]]$fColumnsSplit = @();
                                $fColumnsSplit = $FlagColumns[$j] -split "," | Where-Object {$_.Trim() -ne ""} | Foreach-Object {$_.Trim("").Trim("'");};
                                
                                Foreach($fcs  in $fColumnsSplit)
                                {
                                    $fColIndex = [System.Array]::IndexOf(($columns | Foreach-Object {$_.ToLower()}), $fcs.ToLower());
                                    If($fColIndex -ne -1)
                                    {
                                        If($j -lt $FlagsForeColor.Count)
                                        {
                                            $matchColumnFlag[$fColIndex] = $True;
                                            $fc[$fColIndex] = $FlagsForeColor[$j];
                                        }

                                        If($j -lt $FlagsBackColor.Count)
                                        {
                                            $matchColumnFlag[$fColIndex] = $True;
                                            $bc[$fColIndex] = $FlagsBackColor[$j];
                                        }
                                    }
                                }
                            }
                        }   
                    }
                }
            }

            For($j = 0; $j -lt $columns.Count; $j++)
            {
                $foreColor = $fc[$j];
                $backColor = $bc[$j];

                If ($matchCond)
                {
                    If (!($matchColumnFlag[$j]))
                    {
                        If ($null -ne $RowForeColor)
                        {
                            $foreColor = $RowForeColor;
                        }

                        If ($null -ne $RowBackColor)
                        {
                            $backColor = $RowBackColor;
                        }
                    }
                }
                 
                If ($j -eq 0)
                {
                    $vPos = $headersPos[$j];
                    $vLen = $headersLen[$j];
                }
                else
                {
                    If ($null -ne $RowBackColor -and $matchCond)
                    {
                        Write-Line " " -NoNewline -BackgroundColor $RowBackColor;
                    }
                    else
                    {
                        Write-Line " " -NoNewline -BackgroundColor $BodyBackColor;
                    }

                    $vPos = $headersPos[$j];
                    $vLen = $headersLen[$j];
                }

                # Do not overrun the string buffer
                if (($vpos+$vlen) -ge $maxLength) {
                    $vlen=$maxLength-$vpos
                }

                $valueText = $line.SubString($vPos, $vLen);
                Write-Line -Object $valueText -NoNewline -ForegroundColor $foreColor -BackgroundColor $backColor;
                If ($j -eq $columns.Count - 1)
                {
                    Write-Host;     
                }
            } 
        }
        ElseIf(!($HeadersOnly))
        {
            Write-Line -ForegroundColor $BodyForeColor -BackgroundColor $BodyBackColor $line;
        }

        If ($l -ne ($lines.Length))
        {
            If ($InjectRowsSeparator)
            {
                If (!$RowsSeparator)
                {
                    $RowsSeparator = " ";
                }

                $RowsSeparatorLine =  $RowsSeparator * $line.Length;
                $RowsSeparatorLine = $RowsSeparatorLine.Substring(0, $line.Length);

                Write-Line -Object $RowsSeparatorLine -ForegroundColor $RowsSeparatorForeColor -BackgroundColor $RowsSeparatorBackColor;
            }
        }
    }
}


# From https://github.com/EvotecIT/PSWriteColor
function Write-Color {
   
    [alias('Write-Colour')]
    [CmdletBinding()]
    param ( [String[]]$Text,
        [ConsoleColor[]]$Color = [ConsoleColor]::White,
        [ConsoleColor[]]$BackGroundColor = $null,
        [int] $StartTab = 0,
        [int] $LinesBefore = 0,
        [int] $LinesAfter = 0,
        [int] $StartSpaces = 0,
         [string] $LogFile = '',
        [string] $DateTimeFormat = 'yyyy-MM-dd HH:mm:ss',
        [bool] $LogTime = $true,
        [ValidateSet('unknown', 'string', 'unicode', 'bigendianunicode', 'utf8', 'utf7', 'utf32', 'ascii', 'default', 'oem')][string]$Encoding = 'Unicode',
        [switch] $ShowTime,
        [switch] $NoNewLine,
        [bool] $BlackConsole = $False)
    $DefaultColor = $Color[0]
    if ($null -ne $BackGroundColor -and $BackGroundColor.Count -ne $Color.Count) {
        Write-Error "Colors, BackGroundColors parameters count doesn't match. Terminated."
        return
    }
    if ($LinesBefore -ne 0) { for ($i = 0; $i -lt $LinesBefore; $i++) { Write-Host -Object "`n" -NoNewline } }
    if ($StartTab -ne 0) { for ($i = 0; $i -lt $StartTab; $i++) { Write-Host -Object "`t" -NoNewline } }
    if ($StartSpaces -ne 0) { for ($i = 0; $i -lt $StartSpaces; $i++) { Write-Host -Object ' ' -NoNewline } }
    if ($ShowTime) { Write-Host -Object "[$([datetime]::Now.ToString($DateTimeFormat))] " -NoNewline }
    if ($Text.Count -ne 0) {
        if ($Color.Count -ge $Text.Count) { 
            if ($null -eq $BackGroundColor) { 
                for ($i = 0; $i -lt $Text.Length; $i++) {
                    if ($BlackConsole) {
                        $TextWrite=$BLACKBG + $Text[$i]
                    } else {
                        $TextWrite=$Text[$i]
                    }                     
                    Write-Host -Object $TextWrite -ForegroundColor $Color[$i] -NoNewline 
                } 
            } 
            else { 
                for ($i = 0; $i -lt $Text.Length; $i++) { 
                    if ($BlackConsole) {
                        $TextWrite=$BLACKBG + $Text[$i]
                    } else {
                        $TextWrite=$Text[$i]
                    }
                    Write-Host -Object $TextWrite -ForegroundColor $Color[$i] -BackgroundColor $BackGroundColor[$i] -NoNewline 
                } 
            } 
        } else {
            if ($null -eq $BackGroundColor) {
                for ($i = 0; $i -lt $Color.Length; $i++) {
                    if ($BlackConsole) {
                        $TextWrite=$BLACKBG + $Text[$i]
                    } else {
                        $TextWrite=$Text[$i]
                    }
                    Write-Host -Object $TextWrite -ForegroundColor $Color[$i] -NoNewline 
                }
                for ($i = $Color.Length; $i -lt $Text.Length; $i++) { 
                    if ($BlackConsole) {
                        $TextWrite=$BLACKBG + $Text[$i]
                    } else {
                        $TextWrite=$Text[$i]
                    }
                    Write-Host -Object $TextWrite -ForegroundColor $DefaultColor -NoNewline
                 }
            } else {
                for ($i = 0; $i -lt $Color.Length; $i++) {
                    if ($BlackConsole) {
                        $TextWrite=$BLACKBG + $Text[$i]
                    } else {
                        $TextWrite=$Text[$i]
                    } 
                    Write-Host -Object $TextWrite -ForegroundColor $Color[$i] -BackgroundColor $BackGroundColor[$i] -NoNewline 
                }
                for ($i = $Color.Length; $i -lt $Text.Length; $i++) { 
                    if ($BlackConsole) {
                        $TextWrite=$BLACKBG + $Text[$i]
                    } else {
                        $TextWrite=$Text[$i]
                    }
                    Write-Host -Object $TextWrite -ForegroundColor $DefaultColor -BackgroundColor $BackGroundColor[0] -NoNewline 
                }
            }
        }
    }
    if ($NoNewLine -eq $true) { Write-Host -NoNewline } else { Write-Host }
    if ($LinesAfter -ne 0) { for ($i = 0; $i -lt $LinesAfter; $i++) { Write-Host -Object "`n" -NoNewline } }
    if ($Text.Count -and $LogFile) {
        $TextToFile = ""
        for ($i = 0; $i -lt $Text.Length; $i++) { $TextToFile += $Text[$i] }
        try { if ($LogTime) { "[$([datetime]::Now.ToString($DateTimeFormat))] $TextToFile" | Out-File -FilePath $LogFile -Encoding $Encoding -Append -ErrorAction Stop } else { "$TextToFile" | Out-File -FilePath $LogFile -Encoding $Encoding -Append -ErrorAction Stop } } catch { $PSCmdlet.WriteError($_) }
    }
}

# Probably the most important function in the script. 
# DEBUG check moved into Write-Log
function debug(){
    param ([string]$msg = "")
        
    # Get line number
    if ($global:DEBUG) { 
        $VerbosePreference = 'Continue'
        Write-Verbose -Message "$lineno $msg"
     }
    # Get line number
    $lineno=$MyInvocation.ScriptLineNumber
        
    $lines=$msg.Split([Environment]::NewLine,[StringSplitOptions]::RemoveEmptyEntries)
    foreach ($m in $lines){
        Write-Log -Message $m -Level Info -Path $global:DEBUGLOG -LineNo $lineno
    }
    
}

# Either log to stdout or debug but also write messages to a file
function logdebug {
    param ([string]$msg = "",
           [string]$color = "White")
    
    if ($global:DEBUG) {
        debug $msg
    }
    else {
        Write-Host $msg -ForegroundColor $color
         # Get line number
        $lineno=$MyInvocation.ScriptLineNumber
        Write-Log -Message $msg -Level Info -Path $global:DEBUGLOG -LineNo $lineno
    }     
}

function alert() {
    param ([string]$alert_msg = "Warning!")
    [System.Windows.MessageBox]::Show($alert_msg)
}

# Set the window to our liking
SetupWindow

debug("Debug mode is on...")
debug("Writing logs to $global:DEBUGLOG")

# Figure out if as old as Powershell 2
debug ("Checking Powershell Version")


$PSVERSION=(Get-Host | Select-Object Version).Version.Major

#PowerShell 5.0 Only Colors (sorry Win 7 users)
if ($PSVERSION -eq 5) {
    [char]$ESC = 27 
    $ORANGE="$ESC[38;5;208m"
    $LIME="$ESC[38;5;155m"
    $PURPLE="$ESC[38;5;99m"
    $BEIGE="$ESC[38;5;100m"
    $RED="$ESC[38;5;196m"
    $GREEN="$ESC[38;5;46m"
    $YELLOW="$ESC[38;5;11m"
    $WHITE="$ESC[38;5;15m"
    $BLACKBG="$ESC[48;5;16m"
}

if ($PSVERSION -eq 2) {
    alert("WARNING! Your OS is not supported. This script may fail! Support is for Windows 10 or higher.")
}

function download {
    param ([string]$url,
               [string]$file)
     try {
       
        Write-Host "Downloading $url ... please wait!" -foreground Red
        $WC=new-object system.net.webclient
        $WC.UseDefaultCredentials = $true
         $WC.downloadfile($url, $file)

     }
     catch {
        $e = $_.Exception
        $line = $_.InvocationInfo.ScriptLineNumber
        $msg = $e.Message
        Write-Host "Exeption $e occured with message $e.message"
     }
}

# Create WebClient for older PS versions
$WC=new-object system.net.webclient
$WC.UseDefaultCredentials = $true

debug("POWERSHELL version is $PSVERSION")

# Quick dump of game information
function Show-GameInfo {
    param ([bool]$promptmsg = $true)

    $infoline=("="*30)+" GAME INFO "+("="*30)
    $payload=@(
            (" "*71),
            $infoline,
            ("#",(" "*70))
            ("#","  Script"," Version is [","$VERSION","]"),
            ("#","  Powershell"," Version is [","$PSVERSION","]"),
            ("#","  Store"," is [","$STORE","]"),
            ("#","  Dark Forces Install"," is [","$DFINSTALL","]"),
            ("#","  DosBox CONF Path"," is [","$DOSBOXCONFPATH","]"),
            ("#","  GamePath"," is [","$GAMEPATH","]"),
            ("#","  Resoluton"," is [","$RESOLUTION","]"),
            ("#","  Patched" ," is [", "$global:ISPATCHED","]"),
            ("#","  Log"," is enabled [","$global:WRITE_LOGS","]"), 
            ("#","  LogPath"," is located at [","$global:DEBUGLOG","]"), 
            ("#","  Loaded"," ",$missions.Length," missions."),
            ("#",(" "*70))
            $infoline,
            (" "*71))

    foreach ($msg in $payload) {
        
        if (!($global:DEBUG)) {
            Write-Color $msg -Color Gray,Cyan,White,Yellow,White 
        }
        debug($msg)
    }

    if ($promptmsg) {
        Read-host "Press Enter to continue..."
    }
}

function Show-DosBoxConf {
    param ([bool]$prompt = $false)
    
    $dosboxraw=((gc $DOSBOXCONFPATH | Out-String).trim())
    logdebug " " "Yellow"
    $sep=(("-"*10)," DOSBOX CONF ",("-"*10)) 
    logdebug "Config located at [$DOSBOXCONFPATH]" "Red"
    logdebug " " "Yellow"
    logdebug $sep "Yellow" 
    logdebug " " "Yellow" 
    foreach ($n in $dosboxraw.split([Environment]::NewLine,[StringSplitOptions]::RemoveEmptyEntries)) {
        $pad="  $n"
        if ($n[0] -eq '['){
           logdebug " " "Yellow" 
        }
        logdebug $pad "Yellow" 
    }
    logdebug " " "Yellow" 
    logdebug $sep "Yellow" 

    if ($prompt) {
        Read-Host "Press Enter to Continue..." 
    }
}


# Load the Dosbox Conf file and parse it   
Function Load-DosBoxConfigFile () {

  # We only consume DosBox configuration that have run DARK.EXE executable. 
  # If we do not have it, we restore from DF-21.net 
  #
  # TO DO NOTE: 
  # Yes I know it is possible to have just DARK without the EXE in the autoexec stanza. 
  # But how do you tell DARK executable from some folder called DARK? I am at a loss (for now).
  #  

  # Ensure we have the config first
  if (!(Test-Path $DOSBOXCONFPATH)) {
    Restore-DosboxConfig

    # Since we reload after restoring it, exit immediately. 
    return
  } 
  
  debug("The executable is [$DF_EXECUTABLE]")

  $CONF = New-Object System.Collections.Specialized.OrderedDictionary
  
  debug("Loading DosBox configuration data from $DOSBOXCONFPATH")
  $section = "INIT"
  $CONF[$section] = @{}

  switch -regex -file $DOSBOXCONFPATH {
    "^\[(.+)\]$" {
      $section = $matches[1].Trim()
      $CONF[$section] = @{}
    }
    "^\s*([^#].+?)\s*=\s*(.*)" {
      $name,$value = $matches[1..2]
      if (!($name.StartsWith(";"))) {
        $CONF[$section][$name] = $value.Trim()
      }
    }
  }
  
  # Load autoexec separately since it is a batch file and not a standard INI
  $CONF["autoexec"]=(gc $DOSBOXCONFPATH | Out-String | Select-String '.*\[autoexec\]\s+([^\[]*)').Matches[0].Groups[1].Value.TrimEnd()

  if (!($CONF["autoexec"])) {
    alert ("There is no autoexec stanza in the dosbox file! How are you launching Dark Forces? Exiting...")
    exit
  }

  # Get rid of init stanza
  $CONF.Remove("INIT")
  $global:DOSBOXCONF=$CONF

  # If you are missing DARK.EXE
  if(!($CONF["autoexec"] | Select-String $DF_EXECUTABLE)) {
    debug("There is no executable in $DOSBOXCONFPATH")
    
    # Maybe you still have a stale Mission Batch File in your autoexec?
    $batchfiles=foreach ($mission in $global:missions) { $mission.File }
    
    $global:NOEXECUTABLE=$true

    # Lets hope we find it among the batchfiles
    foreach ($batchfile in $batchfiles) {
        
        if ($CONF["autoexec"] | Select-String $batchfile) {
            debug("Found a batchfile $batchfile in the Autoexec stanza. Replacing with $DF_EXECUTABLE")
            $CONF["autoexec"] = $CONF["autoexec"] -replace $batchfile,$DF_EXECUTABLE
            $global:NOEXECUTABLE=$false    

            # Fix the file
            Write-DosBox-Config
            $global:DOSBOXCONF=$CONF       
            break
        }
    }
  } else {
    $global:NOEXECUTABLE=$false
  }

  # Update resolution variable
  $res=GetDosBoxConfigValue "sdl" "windowresolution"
  if ($res) {
      $global:RESOLUTION=$res
  } else {
    if((GetDosBoxConfigValue "sdl" "fullscreen") -eq "true"){
        $global:RESOLUTION="Full Screen"
    } else {
        $global:RESOLUTION="Windowed"
    }
  }
}

# Write the DOSBOXCONF hashmap back to the DosBox Config File
function Write-DosBox-Config {
    $eol="`n"
    $confstr=""
    foreach ($stanza in $global:DOSBOXCONF.keys) {
        $confstr+=("[$stanza]")+$eol
        if ($global:DOSBOXCONF[$stanza].keys) { 
            foreach ($key in $global:DOSBOXCONF[$stanza].keys) {
                $confstr+=($key+"="+$global:DOSBOXCONF[$stanza][$key]+$eol)
            }
        }
        #autoexec
        else {
            $confstr+=$global:DOSBOXCONF[$stanza]+"`r`n"
        }  
        $confstr+=$eol
    }
    debug("Writing configuration to $DOSBOXCONFPATH")
    debug("-"*60)
    debug($confstr)
    debug("-"*60)

    $confstr | Out-File $DOSBOXCONFPATH -encoding oem
}

# Reset dosbox settings if necessary
function Restore-DosboxConfig {

    # EA and Steam share the same config
    if (($STORE -eq "STEAM") -or  ($STORE -eq "EA")) {
        download $DOSBOX_STEAM_CONF $DOSBOXCONFPATH
    }
    elseif ($STORE -eq "GOG" -or $STORE -eq "STANDALONE") {
        download $DOSBOX_GOG_CONF $DOSBOXCONFPATH
    }
    else {
        debug ("FATAL: About to Crash! Please COPY / Take a screenshot of the ENTIRE log in $global:DEBUGLOG so it can be debugged! ...")
        Read-Host -Prompt "Press Enter to continue"
        alert("Unsure what Store you are using. Exiting...")
        exit
    }

    # If you download a new dosbox config, load up the values
    Load-DosBoxConfigFile
    alert("Settings Reset!")
}

# Get a value from the config
function GetDosBoxConfigValue{
    param ([string]$stanza,
           [string]$key="")
    if ($global:DOSBOXCONF[$stanza]) {
        if ($key) {
            debug ("Loading stanza $stanza key $key with the value $global:DOSBOXCONF[$stanza][$key]")
            return $global:DOSBOXCONF[$stanza][$key]
        }
        else {
            debug ("Loading stanza $stanza with the value $global:DOSBOXCONF[$stanza]")
            return $global:DOSBOXCONF[$stanza]
        }
    }
}

# Update a variable and write the data to dosbox config file
function SetDosBoxConfigValue{
    param ([string]$stanza,
           [string]$key,
           [string]$value)
    debug("Setting stanza $stanza key $key to value $value")

    if ($global:DOSBOXCONF[$stanza]) {
        $global:DOSBOXCONF[$stanza][$key] = $value
    } 
    else {
        # To support Powershell 2.0 - cannot use [ordered]
        $keyval = New-Object System.Collections.Specialized.OrderedDictionary
        $keyval[$key] = $value
        $global:DOSBOXCONF[$stanza]=$keyval
    }

    Write-DosBox-Config
}

# Replace a value in the AutoExec stanza (Ex: DARK.EXE to ASSASSIN.BAT)
function ReplaceDosBoxConfigAutoexecValue{
    param ([string]$origvalue,
           [string]$newvalue) 

    debug ("Updating Autoexec $origvalue with $newvalue")
    $global:DOSBOXCONF["autoexec"]=$global:DOSBOXCONF["autoexec"] -replace $origvalue,$newvalue
    Write-DosBox-Config
}

function FullScreen {
    param ([bool]$full=$true)

    debug("Changing to fullscreen=$full")
    
    if($full) {
        $global:RESOLUTION="Full Screen"
        $global:LASTMESSAGE="Game Changed to Full Screen"
        
        # Reset Output when in Full Screen mode
        SetDosBoxConfigValue "sdl" "output" 
    } 
    SetDosBoxConfigValue "sdl" "fullscreen" $full
}

function Set-RecommendedResolution 
{


    # Retrieve number of buttons on mouse
    $dpi = [DPI]::scaling()
    debug("Original DPI = " + $dpi)
    if (!($dpi -eq 1))
    {
        $dpi = $dpi * 0.9
        debug("Updating DPI to " + $dpi)
    }
    
    $width = ([WinLib.WinLib]::GetSystemMetrics(16) * $dpi  | Out-String).Trim()
    $height = ([WinLib.WinLib]::GetSystemMetrics(17) * $dpi | Out-String).Trim()
    
    debug("width =  " + $width)
    debug("Height =  " + $height)
       
    $global:RESOLUTION=$width+"x"+$height
    SetDosBoxConfigValue "sdl" "windowresolution" $global:RESOLUTION
    
    # Ensure aspect is false
    SetDosBoxConfigValue "render" "aspect" "true"

    # Steam Overlay when in Windowed Mode needs OPENGLNB
    SetDosBoxConfigValue "sdl" "output" "openglnb"
    
    debug("The new resolution is $global:RESOLUTION")
    $global:LASTMESSAGE="Resolution has been updated to $global:RESOLUTION"
}

# Choose a resolution or pick full screen
function Change-Resolution {

    # If you are going windowed - then disabling fullscreen
    FullScreen $false

    debug("Choosing a new resolution")    
    $resolutions = ("1920x1200 (16:10)",
                    "1280x800 (16:10)",
                    "640x400 (16:10)",
                    "320x200 (16:10)",
                    "2560x1440 (16:9)",
                    "19201080 (16:9)",
                    "1600x900 (16:9)",
                    "1360x768 (16:9)",
                    "1280x1024 (5:4)",
                    "1600x1200 (4:3)",
                    "1200x900 (4:3)",
                    "1024x768 (4:3)",
                    "1200x800 (3:2)" )
    do {
        try {
            if (!($DBUG)) { Clear-Host }
            Write-Host
            Write-Host ("-"*30)
            Write-Host
            Write-Color "Important Note!"," Set the resolution height that is"," LESS ","than your monitor height" -Color Yellow,White,Yellow,White 
            Write-Color "Example:"," If you have a ","1920x1080"," Monitor then choose ","1600x900"," or ","1200x800" -Color Yellow,White,Cyan,White,Cyan,White,Cyan            
            Write-Host
            Write-Color "Current Resolution is [","$global:RESOLUTION","]" -Color White,Cyan,White
            Write-Host
            Write-Host "Window Resolution List"
            Write-Host

            for ($idx=1; $idx -le $resolutions.Length; $idx++){
                Write-Color $idx," : ", $resolutions[$idx-1] -Color Red,White,Yellow
            }
            Write-Host
            Write-Host ("-"*30)
            Write-Host
            Write-Color "Important Note!"," Set the resolution height that is"," LESS ","than your monitor height" -Color Yellow,White,Yellow,White 
            Write-Host
            Write-Color "Streamers:", " If you are using OBS then in the Sources choose", " Window Capture ", "instead of", " Game Capture ","." -Color Yellow,White,Green,White,Cyan,White
            Write-Host
            $res=(Read-Host $WHITE"Pick a resolution "$RED"#"$WHITE" press "$GREEN"A"$WHITE" to set resolution "$GREEN"Automatically"$WHITE" or "$ORANGE"M"$WHITE" to go back to the "$ORANGE"Main Menu"$WHITE).toLower()
            debug("You've chosen resoluton option $res")
            
            # Exit to Main Menu
            if ($res.ToLower() -eq 'm') { return }

            # Automatically set
            if ($res.ToLower() -eq 'a') { Set-RecommendedResolution; return }

            $res=[int32]($res)
        }
        catch {
            Write-Host "Please enter a valid number. You typed [$res]"
            $res=""
        }
       
    }
    until ($res.GetType().Name -eq "Int32" -and ($res -ge 1 -and $res -le $resolutions.Length))
    $global:RESOLUTION=($resolutions[$res-1]).Split()[0]

    SetDosBoxConfigValue "sdl" "windowresolution" $global:RESOLUTION
    
    # Ensure aspect is false
    SetDosBoxConfigValue "render" "aspect" "true"

    # Steam Overlay when in Windowed Mode needs OPENGLNB
    SetDosBoxConfigValue "sdl" "output" "openglnb"
    
    debug("The new resolution is $global:RESOLUTION")
    $global:LASTMESSAGE="Resolution has been updated to $global:RESOLUTION"
}
      
# Simple Download function 
function download {
    param ([string]$url,
           [string]$file)
    try {
       
        debug("Downloading $url to $file")
        Write-Host "Downloading $url ... please wait!" -foreground Red
        if ($PSVERSION -eq 2) {
            # Rising antivirus flags any "downloadfile" (PS2) as a Virus.
            # Which is garbage since it allows Invoke-WebRequest (PS5)
            $WC.downloadfile($url, $file)
        }
        else {
            Invoke-WebRequest $url -OutFile $file
        }
     }
     catch {
        $e = $_.Exception
        $line = $_.InvocationInfo.ScriptLineNumber
        $msg = $e.Message
        debug("Exeption $e occured with message $e.message")
        alert("Error while downloading [$url] to [$file] due to [$msg]")
     }

}

# Extract Files
function extract {
    param ([string]$zipfile,
           [string]$file)
    debug("Extracting $zipfile to $file ...")
    if (($PSVERSION -eq 2) -or ($PSVERSION -eq 4)) {
        # In PowerShell 2, need to manually extract them
        $shell = new-object -com shell.application
        $zip = $shell.NameSpace($zipfile)
        foreach($item in $zip.items()) {
            $shell.Namespace($file).copyhere($item, 0x14)
        }
    } else {
        Expand-Archive $zipfile -DestinationPath $file -Force
    }
}


# Backup a file (typically a config)
function Backup {
    param ([string]$filetobackup,
           [bool]$reverse=$false,
           [string]$suffix="_BACKUP")

    $backfile=$filetobackup + $suffix
    if ($reverse) {
        Copy-Item $backfile -Destination $filetobackup -Force
        debug ("Copying $backfile to $filetobackup")
    }
    else {
        Copy-Item $filetobackup -Destination $backfile -Force
        debug ("Copying $filetobackup to $backfile")
    }

}

# Restore your backup (dosbox.conf) and reload the configuration
function RestoreBackUp
{
    debug ("Sleeping for 15 seconds...")

    # Wait for game to Launch and then restore the configuration
    # What's a good time for all systems? I mean even the slowest
    # Should start this game in 15 seconds right..? Right??
    Start-Sleep -s 15

    debug("Restoring Backup Configuration")

    #Restore dosbox.conf 
    backup $DOSBOXCONFPATH $true
    
    # Reload original configuration so as not to pollute dosbox
    Load-DosBoxConfigFile
}

#  This replaces DosBox and assumes the path exists
function Replace-Dosbox {
    param ([string]$DFGamePath)
    
    debug("Replacing DosBox")
    
    download $DOSBOX_URL $DFGamePath"/DosBox.zip"
    extract $DFGamePath"/DosBox.zip" $DFGamePath

    download $DOSBOX_GOG_CONF $DFGamePath"/dosbox_DF_single.conf"

}

# Load mission file CSV from DF-21.
function Load-MissionFiles {
    
    # Download the maps or use the hardcoded version
    if($DOWNLOAD_MISSION_CSV){

        # We always redownload the CSV to update new maps
        debug("Downloading custom missions CSV")
        download $DF_LEVELS_URL $DF_CSV_FILE
    }
    else {

       # Only write a hardcoded version if you do not have an existing one
       if (!(Test-Path $DF_CSV_FILE)) {
            
            debug("Skipping mission CSV load, writing a hardcoded version")
            Add-Content -Path $DF_CSV_FILE  -Value '"Title","URL","File","Author","Walkthrough"'
            $maps=@(
                '"Boba Fett: Episode I Assassination on Nar Shaddaa.","http://df-21.net/downloads/uploads/1436751515/assassin.zip","assassin.bat","Barry Brien","https://www.youtube.com/watch?v=ar1oU6boWO4"'
                '"Cloudspear: Part I The Ghosts of Takyr.","http://df-21.net/downloads/conf_files/cspear1new.zip","cspear1.bat","Kevin Buscemi","https://www.youtube.com/watch?v=ChdrgJQSAQI"'
                '"The Dark Tide Episode 1: Wasteland Survivor.","http://df-21.net/downloads/uploads/1212146665/dt1se.zip","dt1se.bat","Patrick Haslow and Matt Hallaron","https://www.youtube.com/watch?v=6egS0GQlu54"'
                '"Tie Defender Base.","http://df-21.net/downloads/uploads/812658857/defbase.zip","DEFBASE.BAT","Paul Nemesh","https://www.youtube.com/watch?v=iYRunh7eAiI"'
                '"Beyond Glory 2 In Dying Light","http://df-21.net/downloads/uploads/1863078917/bglory2.zip","bglory2.bat","Kevin Buscemi","https://www.youtube.com/watch?v=ALApxT-Dw44"'
                '"Fortress Quadragon","http://df-21.net/downloads/uploads/566902558/fortquad.zip","FORTQUAD.BAT","Oton Ribic","https://www.youtube.com/watch?v=bzcYlE1KuRs"'
                '"Critak Moon: The Imperial Outpost","http://df-21.net/downloads/uploads/1107274281/ioutpost.zip","IOUTPOST.BAT","Llyren Adwyr","https://www.youtube.com/watch?v=GbjgoSdB3uU"'
                '"Asteroid","http://df-21.net/downloads/uploads/2090139591/asteroid.zip","asteroid.bat","Eric Parker","https://www.youtube.com/watch?v=Zetha5BqEbk"'
                '"The Dark Tide Episode 2: Nightfall","http://df-21.net/downloads/uploads/1391356948/dtide2.zip","DTIDE2.BAT","Patrick Haslow and Matt Hallaron","https://www.youtube.com/watch?v=bWCOi6LC2ao"'
                '"Dark Tide: Episode IV Empire","http://df-21.net/downloads/uploads/1745302688/dtide4.zip","DTIDE4.BAT","Barry Brien, Mat Hallaron, and Patrick Haslow","https://www.youtube.com/watch?v=HXCCLxUi6YQ&list=PL4V3Cs5q0vBvXlcPsLsNJMCMnZt7KxnoQ&index=47"'
            )
            $maps | foreach { Add-Content -Path  $DF_CSV_FILE -Value $_ }
       }

    }
    

    # Load the custom maps, whatever the source
    if (test-path $DF_CSV_FILE) {
        debug("Loading custom level list from $DF_CSV_FILE")
        $missions= Import-Csv  $DF_CSV_FILE
    }

    if (!($missions)) {
       alert("Warning could not download any missions. Please check if www.df-21.net is down! ")
    } else {

        # Prepend an Index column for pretty-printing
        $script:index = 1
        $global:missions = $missions| Select-Object @{ Name = "Index"; Expression = { $script:index; $script:index+= 1 }}, *
        debug($global:missions| Out-String)
    }
}


# Validate Dark Forces and restore it
function Restore-DarkForces
{
    debug ("Restoring Dark Forces...")
    if ($STORE -eq "STEAM") {
        StartProcessWrapper steam://validate/32400 
       
        $global:LASTMESSAGE="Steam Dark Forces has been restored"
        Restore-DosboxConfig
    }
    else {
        alert ("This command only works on the Steam Version of Dark Forces")
    }
}

# Walkthrough Section
function Walkthroughs
{
    # Keep track of Mission Pages
    $page=0
    $pagestoshow=20

    # Store the number reference default
    $missionnum=0
    $total_pages=[Math]::ceiling($missions.Length/$pagestoshow)
    do {

        function Show-Walkthroughs
        {

            debug("Inside the Walkthroughs Menu")

            if (!($DBUG)) { Clear-Host }
            Write-Color ("-"*58)," ",$missions.Length," Walkthroughs ",("-"*58) -Color White,White,Yellow,Yellow,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Host (" "*134) -BackgroundColor Black     
            Write-Color "   To open a ","Youtube Walkthrough"," simply choose a Mission from the List",(" "*64) -Color White,Red,White -BackGroundColor Black,Black,Black
            Write-Host (" "*134) -BackgroundColor Black     
            Write-Color "   Press [","N","] to see the ","Next Page"," of Walkthroughs ",(" "*84) -Color White,Green,White,Green,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Color "   Press [","P","] to see the ","Previous Page"," of Walkthroughs ",(" "*80) -Color White,Cyan,White,Cyan,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Color "   Press [",$ORANGE"M"$WHITE,"] to go back to the ",$ORANGE"Main Menu"$WHITE,".",(" "*93) -Color White,Red,White,Red,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Color "   Press [",$PURPLE"Q"$WHITE,"] to ",$PURPLE"Quit"$WHITE," the launcher.",(" "*100) -Color White,Gray,White,Gray,White -BackGroundColor Black,Black,Black,Black,Black           
            Write-Host (" "*134) -BackgroundColor Black 
            Write-Color ("-"*62)," Page [",($Page+1),"/$total_pages] ",("-"*60) -Color White,White,Yellow,White,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Host
            if ($missions)  {
                Write-PSObject $missions[($page*$pagestoshow)..((($page+1)*$pagestoshow)-1)] -column "Index","Title","Author","Walkthrough" -ColoredColumns "Index", "Title","Author","URL" -ColumnForeColor Red,Cyan,Magenta,Green  -HeadersForeColor Yellow
            }
            Write-Host 
            Write-Color ("-"*62)," Page [",($Page+1),"/$total_pages] ",("-"*60) -Color White,White,Yellow,White,White -BackGroundColor Black,Black,Black,Black,Black
        }
        Show-Walkthroughs

        $walkselection = (Read-Host "Please choose a walkthrough"$RED"#"$WHITE or "$ORANGE"M$WHITE to go back to the "$ORANGE"Mission Menu"$WHITE").ToLower() 
        
        debug("You have chosen [$walkselection]")

        $is_integer=[Int32]::TryParse($walkselection,[ref]$missionnum)

        if ($is_integer -and (($missionnum -ge 1) -and ($missionnum -le $missions.Length))) {
    
            $missionwalk=$missions[$missionnum-1].Walkthrough

            if ($missionwalk -eq "Unavailable") {
                $missiontitle=$missions[$missionnum-1].Title
                alert("Sorry, there is no walkthrough for $missiontitle")
         
            } else {
                debug("Starting walkthrough $missionwalk")
                StartProcessWrapper $missionwalk
            }
        }
        else {

            switch($walkselection)
            {
                # Go back to the main menu
                'm' { return }

                # Exit
                'q' { exit }

                # Increment Page
                'n' { if ((($page+1)*($pagestoshow) -lt $missions.Length) -and ($pagestoshow -le $missions.length)){ $page+=1 }}

                # Decrement Page
                'p' { if ($page -ge 1){ $page-=1 }}
            }
        }
    }
    until  ($false)

}

# Show the menu for custom maps
function SelectCustomMap
{
    # Keep track of Mission Pages
    $page=0
    $pagestoshow=20

    # Store the number reference default
    $missionnum=0
    $total_pages=[Math]::ceiling($missions.Length/$pagestoshow)

    do {

        function Show-CustomMaps 
        {
            debug("Inside the Custom Missions Menu")

            if (!($DBUG)) { Clear-Host }
            Write-Color ("-"*57)," ",$missions.Length," Custom Missions ",("-"*57) -Color White,White,Yellow,Yellow,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Host (" "*134) -BackgroundColor Black
            Write-Color "   NOTE",": If you choose a mission, it will launch ","immediately!",(" "*73) -Color Red,White,Red -BackGroundColor Black,Black,Black
            Write-Host (" "*134) -BackgroundColor Black
            Write-Color "   Press [","N","] to see the ","Next Page"," of Missions ",(" "*88) -Color White,Green,White,Green,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Color "   Press [","P","] to see the ","Previous Page"," of Missions ",(" "*84) -Color White,Cyan,White,Cyan,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Color "   Press [","W","] to see the ","Walkthroughs",". Use this option if you are stuck!",(" "*63) -Color White,Yellow,White,Yellow,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Color "   Press [",$ORANGE"M","] to go back to the ",$ORANGE"Main Menu",".",(" "*93) -Color White,Red,White,Red,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Color "   Press [",$PURPLE"Q","] to ",$PURPLE"Quit"," the launcher.",(" "*100) -Color White,Gray,White,Gray,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Host (" "*134) -BackgroundColor Black
            Write-Color ("-"*62)," Page [",($Page+1),"/$total_pages] ",("-"*60) -Color White,White,Yellow,White,White -BackGroundColor Black,Black,Black,Black,Black
            Write-Host 
            if ($missions)  {
                Write-PSObject $missions[($page*$pagestoshow)..((($page+1)*$pagestoshow)-1)] -column "Index","Title","URL","Author" -ColoredColumns "Index", "Title","Author","URL" -ColumnForeColor Red,Cyan,Magenta,Green  -HeadersForeColor Yellow
            }
            Write-Host 
            Write-Color ("-"*62)," Page [",($Page+1),"/$total_pages] ",("-"*60) -Color White,White,Yellow,White,White -BackGroundColor Black,Black,Black,Black,Black
        }
        Show-CustomMaps

        $mapselection = (Read-Host "Please choose a mission"$RED"Index #"$WHITE" or "$ORANGE"M$WHITE to go back to the"$ORANGE" Main Menu$WHITE").ToLower() 

        debug("You have chosen [$mapselection]")

        $is_integer=[Int32]::TryParse($mapselection,[ref]$missionnum)

        if($is_integer -and (($missionnum -ge 1) -and ($missionnum -le $missions.Length))) {
            $missionurl=$missions[$missionnum-1].URL
            $missionfile=$missions[$missionnum-1].File
   
            # Run the custom mission the user has chosen.
            RunCustomMission $missionurl $missionfile
        }
        else {

            switch($mapselection)
            {
                # Go back to the main menu
                'm' { return }

                # Exit 
                'q' { exit }

                # Walkthrough section
                'w' { Walkthroughs }

                # Increment Page
                'n' { if ((($page+1)*($pagestoshow) -lt $missions.Length) -and ($pagestoshow -le $missions.length)){ $page+=1 }}

                # Decrement Page
                'p' { if ($page -ge 1){ $page-=1 }}
            }
        }
    }
    until  ($false)
}

#Remove prior LFDs such as DFBrief.lfd and other file as they may cause conflicts
function CleanUpAssets() {
    
    $assets=("*.lfd","text.msg","*.gmd", "*.pal")

    foreach ($asset in $assets) {

        # Clean assets
        if (Test-Path $GAMEPATH\$asset) {
            debug("Removing $asset files from $GAMEPATH")
            Remove-Item "$GAMEPATH\$asset" -Force
        }
     }
}

# Sanity check warning.
function DosBoxRunning {
     if (get-process "dosbox" -ea SilentlyContinue) {
        $dosboxmsg="Warning: Dosbox.exe is already running. Are you trying to launch two instances of Dark Forces?"
        debug($dosboxmsg)
        alert ($dosboxmsg)
     }
}

# Patch Dark Forces
function PatchDarkForces {
    param ([bool]$mutealert=$false)

    try {
        debug("Running PATCH URL = [$PATCH_URL]")

        DosBoxRunning
        CleanUpAssets

        $ALREADY_PATCHED=$FALSE
        $PATCHDL=$env:TEMP+"\dfpatch.zip"

        # Backup LFD and GO
        $LFDPATH = $GAMEPATH + '\DFBRIEF.LFD'
        $TARGETLFDPATH = $GAMEPATH + '\LFD\DFBRIEF.LFD' 
        $GOBPATH = $GAMEPATH + '\DARK.GOB'
        $GOBPATHBAK = $GAMEPATH + '\DARK.GOB_BAK'

        if ($global:ISPATCHED) {

            $done=$false
            $ALREADY_PATCHED=$TRUE

            do {
                if (!($DBUG)) { Clear-Host }
                $patch=Read-Host "This Game is already Patched! Download it again (Y)es / (N)o?" 
                switch($patch.ToLower())
                 {

                  'y' { $done = $TRUE }
                  'n' { return }
                 }
            }
            until  ($done)
        }

        download $PATCH_URL $PATCHDL

        # Don't re-backup if already patched
        if (!($ALREADY_PATCHED)) {

            # Backup LFD
            Copy-Item $TARGETLFDPATH -Destination $TARGETLFDPATH'_BAK' -Force

            # Backup GOB
            Copy-Item $GOBPATH -Destination $GOBPATHBAK -Force
        }

        # Extract
        extract $PATCHDL $GAMEPATH

        if (!(Test-Path $GOBPATH)) {
            alert ("Missing DARK.GOB in path $GOBPATH (Extract Failed?)")
            return
        }

        if (!(Test-Path $LFDPATH)) {
            alert ("Missing DFBRIEF.LFD in path $LFDPATH (Extract Failed?)")
            return
        }

        # Put new LFD in the right path
        Copy-Item $LFDPATH -Destination $TARGETLFDPATH -Force

        Write-Host "Patched Dark Forces! Go to Help (H) Menu to Undo"
        start-Sleep -s 1

        if (!($mutealert)) { alert ("Dark Forces is Patched!") }

        
    }
    catch {
        $err = $_
        debug("Failed to Patch Dark Forces due to [$err]")
        Alert ("An error occurred while patching dark forces. [$err]")
        
    }
   
   # Confirm Patch Status
   IsPatched

}

function RetoreDarkForcesPatch {

    debug ('Restoring Patch')

    # Backup LFD and GO
    $LFDBAKPATH = $GAMEPATH + '\LFD\DFBRIEF.LFD_BAK'
    $TARGETLFDPATH = $GAMEPATH + '\LFD\DFBRIEF.LFD' 
    $GOBBAKPATH = $GAMEPATH + '\DARK.GOB_BAK'
    $TARGETGOBPATH = $GAMEPATH + '\DARK.GOB'

    if (!(Test-Path $LFDBAKPATH)) {
        alert ("Missing Backup DFBRIEF.LFD_BAK in path $LFDBAKPATH!")
        return
    }

    if (!(Test-Path $GOBBAKPATH)) {
        alert ("Missing Backup DARK.GOB_BAK in path $GOBBAKPATH ")
        return
    }

    # Restore LFD
    Move-Item $LFDBAKPATH -Destination $TARGETLFDPATH -Force

    # Restore GOB
    Move-Item $GOBBAKPATH -Destination $TARGETGOBPATH -Force
    
    # Confirm Patch Status
    IsPatched

    alert('Patch Reverted. Dark Forces *should* be clean!')
}

# Run the custom map after being provided the ur and batch filename
function RunCustomMission {
    param ([string]$missionurl,
           [string]$missionbat)
    
    DosBoxRunning

    $missionfilepath=$GAMEPATH+"\"+$missionbat
    $missiondestfile=$env:TEMP+"\"+($missionurl.split("/")[-1])

    debug("Mission URL = [$missionurl]")
    debug("Mission Batch File = [$missionbat]")
    debug("Mission Batch FilePath = [$missionfilepath]")
    debug("Mission Destination File = [$missiondestfile]")    

    # Prior to launching a custom map, nuke the prior LFDs
    CleanUpAssets
    
    # Download and extra the map only if it exists
    if (!(Test-Path $missiondestfile)) {
        download $missionurl $missiondestfile
    }
    extract $missiondestfile $GAMEPATH

    # Make a backup of dosbox.conf
    backup $DOSBOXCONFPATH

    # Ensure the batch file exits (This line may be removed 
    if ((gc $missionfilepath)[-1] -ne "exit") {     
        Add-Content -Path $missionfilepath -Value `r`nexit
    }    

    # Replace the DARK.EXE with MISSION.BAT
    debug("Updating executable info...")
    ReplaceDosBoxConfigAutoexecValue $DF_EXECUTABLE $missionfile

    debug("Updating memory...")
    SetDosBoxConfigValue "dosbox" "memsize" "64"

    debug("Updating cpu...")
    SetDosBoxConfigValue "cpu" "cycles" "60000"

    RunDarkForces $false
}

function RunMouseConfig {

    $MOUSELOOKFILE_PATH="$GAMEPATH\$MOUSELOOK_FILE"
    
    debug ("Checking if Mouselook Script exists at $MOUSELOOKFILE_PATH ")
    
    # Ensure you have 1.4 version of Mouselook
    if (!(Test-Path $MOUSELOOKFILE_PATH) -or ((Get-ItemProperty $MOUSELOOKFILE_PATH).VersionInfo.ProductVersion -ne "1.4")) {
        download $MOUSELOOK_URL "$env:TEMP\mouselook.zip"
        extract "$env:TEMP\mouselook.zip" $GAMEPATH

        debug("Starting Mouselok Script.")
    }
    
    pushd $GAMEPATH
    StartProcessWrapper $MOUSELOOKFILE_PATH
    popd 
}


# Wrapper for processes ensures we do not 
# throw spurious Powershell 2.0 errors. 
function StartProcessWrapper {
    param ([string]$process,
           [string]$pargs)
    try {
        if ($pargs) {
            debug("Starting start-process -FilePath $process -ArgumentList $pargs")
            start-process -FilePath $process -ArgumentList "''$pargs''"
        }
        else {
            debug("Starting start-process -FilePath $process")
            start-process -FilePath $process
        }
    }
    catch {
        $err = $_
        # Ignore not running issues on PS Version 2, it won't work with Steam.
        if (!($PSVERSION -eq 2 -and ( $err | Select-String -pattern "is not running" ))) {
            Alert ("An error occurred launching process [$process]")
        }
    }
}

# Probably the most useless function in the script
function RunDarkForces{

    param ([bool]$standalone=$true)

    if ($global:NOEXECUTABLE) {
        alert("You can't start the game without DARK.EXE . Go to Help Menu (H) and press (U) to Update Dosbox.conf")
        return
    }

    debug ("Launching Game...")

    # Ensure CD.ID and Drive.CD exist
    if (!(Test-Path $GAMEPATH\CD.ID)) {
        download $DOSBOX_CDID $GAMEPATH\CD.ID
    }

    if (!(Test-Path $GAMEPATH\DRIVE.CD)) {
        download $DOSBOX_DRIVE $GAMEPATH\DRIVE.CD
    }

    # If we are just running DF by itself, and not a custom map 
    # then remove prior LFDs to prevent corruption
    if ($standalone) {
        DosBoxRunning
        CleanUpAssets
    }

    # Force CPU updates for smoother gameplay
    debug("Updating cpu...")
    SetDosBoxConfigValue "cpu" "cycles" "auto"

    # Forces Direct Draw on Windows 7 versions
    if ($PSVERSION -eq 2) {
        SetDosBoxConfigValue "sdl" "output" "ddraw"
    }

    #Launch game
    if ($STORE -eq "STEAM") {
        StartProcessWrapper steam://rungameid/32400
    }
    elseif($STORE -eq "GOG") {

        # Find out the GOG launch command
        $DOSBOX_FLD=(Get-ItemProperty -Path HKLM:\\Software\\Wow6432Node\\GOG.com\Games\1421404433 -Name DOSBOXFOLDER).DOSBOXFOLDER
        $PARAMS=(Get-ItemProperty -Path HKLM:\\Software\\Wow6432Node\\GOG.com\Games\1421404433 -Name launchParam).launchParam
        pushd $DOSBOX_FLD
        StartProcessWrapper .\DOSBox.exe "$PARAMS"
        popd
    }
    elseif($STORE -eq "EA") {
        pushd $DFINSTALL
        StartProcessWrapper .\EALaunchHelper.exe
        popd
    }
    elseif($STORE -eq "STANDALONE" ) {
        pushd $GAMEPATH\dosbox
        $PARAMS=$STANDALONECONF+' -conf "'+$DOSBOXCONFPATH+'" -noconsole -c "exit"'
        StartProcessWrapper $DOSBOXEXE $PARAMS
        popd
    }
    else {
        if ($global:DEBUG) {
            Write-Host "FATAL: About to Crash! Please COPY / Take a screenshot of the ENTIRE log $global:DEBUGLOG and send to Karjala#9909 so it can be debugged! ..."
        }
        alert("Unsure what Store you are using. Exiting...")
        exit
    }

    # Restore the backup if not standalone
    if (!($standalone)) {
        RestoreBackUp
    }
}

# Simple Debug toggle 
function ToggleDebug {
    if ($global:DEBUG) {
        $global:DEBUG=$false
        $global:LASTMESSAGE="Disabled Debug Mode"
    }
    else {
        $global:DEBUG=$true
        $global:LASTMESSAGE="Enabled Debug Mode"
    }
    debug($global:LASTMESSAGE)
}

# Simple Log toggle 
function ToggleLogs {
    if ($global:WRITE_LOGS) {
        $global:WRITE_LOGS=$false
        $global:LASTMESSAGE="Logs disabled"
    }
    else {
        $global:WRITE_LOGS=$true
        $global:LASTMESSAGE="Logs enabled and writing to $global:DEBUGLOG"
        
    }
    debug($global:LASTMESSAGE)
}

# Help Menu Loop
function Help{
    
    do {
        
        function Show-HelpMenu
        {

            debug("Inside the Help Menu")
            
            if (!($global:DEBUG)) { Clear-Host }
            Write-Color ("-"*30)," Help Menu ",("-"*30) -Color White,Yellow,White -BackgroundColor Black,Black,Black -BlackConsole $True
            Write-Color (" "*71) -Color White -BlackConsole $True
            Write-Color "D: Press 'D' to Enable/Disable Debug messages ",(" "*25)  -Color "Yellow" -BlackConsole $True
            Write-Color $ORANGE"L: Press 'L' to Enable/Disable Logging ",(" "*32)  -Color "White" -BlackConsole $True
            Write-Color "G: Press 'G' to display Game information ",(" "*30) -Color "Gray" -BlackConsole $True
            Write-Color "S: Press 'S' to view the current DosBox Settings ",(" "*22) -Color "Magenta" -BlackConsole $True
            Write-Color "V: Press 'V' to play the Video for Mouselook instructions (v1.3) ",(" "*6) -Color "Green" -BlackConsole $True
            Write-Color "R: Press 'R' to Restore Dark Forces to original settings (STEAM ONLY)  " -Color "Red" -BlackConsole $True
            Write-Color "U: Press 'U' to Update DosBox Settings to the default configuration    "  -Color "Cyan" -BlackConsole $True
            Write-Color "M: Press 'M' to return to the Main Menu ",(" "*31)  -Color "DarkGreen" -BlackConsole $True
            Write-Color "P: Press 'P' to Revert the Dark Forces Patch ",(" "*26)  -Color "Red" -BlackConsole $True
            Write-Color $PURPLE"Q: Press 'Q' to Quit the launcher ",(" "*37) -Color "DarkGray" -BlackConsole $True
            Write-Color (" "*71) -Color White -BlackConsole $True
            Write-Color ("-"*30)," Help Menu ",("-"*30) -Color White,Yellow,White -BackgroundColor Black,Black,Black
        }
        Show-HelpMenu

        if ($global:LASTMESSAGE) {
            Write-Host "$global:LASTMESSAGE" -ForegroundColor "Yellow"
            Write-Host
        }

         # Reset LASTMESSAGE
        $global:LASTMESSAGE=""

        $helpselection = (Read-Host "Please choose a Help option").ToLower() 
        debug("You've chosen option [$helpselection]")

        switch($helpselection)
        {

             # Watch Video
            'v' { StartProcessWrapper "http://youtu.be/pD2wvUF1oy4"}

            # Display DosBox Configuration 
            's' { Show-DosBoxConf $true}

            # Toggle Logging
            'l' { ToggleLogs }

            # Update Dosbox Config
            'u' { Restore-DosboxConfig }

            # Show Game Launcher details and paths
            'g' { Show-GameInfo }

            # Enables Debug Mode
            'd' { ToggleDebug }

            # Go back to the main menu
            'm' { return }

            # Revert Patch
            'p' { RetoreDarkForcesPatch }

            # Restore DarkForces
            'r' { Restore-DarkForces }

            # Exit the launcher
            'q' { exit }

        }
    }
    until  ($helpselection -eq 'm')

}

# All those folks that helped make this script. 
function Acknowledgements{
    
    do {
        function Show-Acknowledgements
        {

            debug("Inside the Acknowledgements Menu")

            if (!($global:DEBUG)) { Clear-Host }
            Write-Color ("-"*29)," Acknowledgements ",("-"*29) -Color White,Yellow,White -BackgroundColor Black,Black,Black
            Write-Host  "#                                                                          #"  -BackgroundColor "Black"
            Write-Color  "#  Contact me on discord here ","https://discord.gg/6T9NvMh2MC","                #" -Color White,Red,White -BackgroundColor Black,Black,Black
            Write-Host  "#                                                                          #"  -BackgroundColor "Black"
            Write-Host  "#  Acknowledgements:                                                       #"  -BackgroundColor "Black"
            Write-Host  "#                                                                          #"  -BackgroundColor "Black"
            Write-Color "#  ","Princessruri", " and ","http://df-21.net"," for hosting the files. Go visit them! #"  -Color White,Magenta,White,Cyan,White -BackgroundColor Black,Black,Black,Black,Black
            Write-Color "#  ","-=CHE@TER=-", " for MouseLook Utility at ","http://ctpax-cheater.losthost.org","  #"  -Color White,DarkGray,White,Green,White -BackgroundColor Black,Black,Black,Black,Black
            Write-Host  "#                                                                          #"  -BackgroundColor "Black"
            Write-Color "#  Everyone who helped me test the script!                                 #"  -BackgroundColor "Black"
            Write-Host  "#                                                                          #"  -BackgroundColor "Black"
            Write-Color "#  ","Dzierzan, Diago77, ImminentOrbit, Numidium, Bela Lugosi's Fed,          ","#" -Color White,Red,White -BackgroundColor Black,Black,Black
            Write-Color "#  ","Kyle_Latarn33, Klasodeth, Phredreeke, Weregoose, Rajerel, DatMaxNub     ","#" -Color White,Red,White -BackgroundColor Black,Black,Black
            Write-Color "#  ","J.King, Rajeral, Nakogama, Zaratul, GeorgeWAmbush and many more         ","#" -Color White,Red,White -BackgroundColor Black,Black,Black 
            Write-Host  "#                                                                          #"  -BackgroundColor "Black" 
            Write-Color ("-"*29)," Acknowledgements ",("-"*29) -Color White,Yellow,White -BackgroundColor Black,Black,Black                                                                                  #"
            Write-Host
            Write-Host "D: Press 'D' to visit www.df-21.net"  -ForegroundColor "Yellow" 
            Write-Host "K: Press 'K' to get help on discord"  -ForegroundColor "Red" 
            Write-Host "F: Press 'F' to visit The Force Engine site at http://theforceengine.github.io/" -ForegroundColor "Cyan"
            Write-Host "C: Press 'C' to visit http://ctpax-cheater.losthost.org/" -ForegroundColor "Green"
            Write-Host "M: Press 'M' to return to the Main Menu"  -ForegroundColor "Magenta"
            Write-Host "Q: Press 'Q' to Exit the launcher"-ForegroundColor "DarkGray"
            Write-Host

        }
        Show-Acknowledgements

        $ackselection = (Read-Host "Please choose an option").ToLower() 
        debug("You've chosen option [$ackselection]")

        switch($ackselection)
        {

             # Go to DF21
            'd' { StartProcessWrapper "http://df-21.net/"}

            # Go to Cheater's site
            'c' { StartProcessWrapper "http://ctpax-cheater.losthost.org" }

            # Go to The Force Engine
            'f' { StartProcessWrapper "http://theforceengine.github.io/" }

            # Go to Discord 
            'k' { StartProcessWrapper "https://discord.gg/6T9NvMh2MC" }

            # Go back to the main menu
            'm' { return }

            # Exit the launcher
            'q' { exit }

        }
    }
    until  ($ackselection -eq 'm')
}

try {
    #PS 2.0 hack
    $ErrorActionPreference = "stop"
    $STEAMROOT=(Get-ItemProperty -Path HKLM:\\Software\\Wow6432Node\\Valve\\Steam -Name InstallPath).InstallPath
}
catch {
    $ErrorActionPreference = "continue"
    debug("Steam is not in the Registry")
}

$ACFPATH=$STEAMROOT+"\steamapps\appmanifest_32400.acf"

debug("STEAMROOT = $STEAMROOT")
debug("ACFPATH = $ACFPATH")
debug("Checking if [$ACFPATH] exists")

# Check if Steam drive has Dark Forces ACF for app 32400'
if (Test-Path $ACFPATH ) {
 
    debug("Path [$ACFPATH] Exists")
    debug("STEAMINSTAL to [$STEAMROOT\steamapps\common\Dark Forces]")
    
    # It exists, great we found Steam's DF directory.
    $STEAMINSTALL=$STEAMROOT+"\steamapps\common\Dark Forces"
} 
else { 
    
    debug("Path [$ACFPATH] does not exist")

    # Otherwise go through all the drives and see which one has it. Check the library folders for drive info.
    $LIBVDFPATH="$STEAMROOT\steamapps\libraryfolders.vdf"
    if (Test-Path $LIBVDFPATH) { 
        $matches= ((gc $LIBVDFPATH)  |Select-String '"path"\s+"(.*?)"').Matches
    
        # For PS2 Compatibility
        if ($matches) {

            # For each drive see if it has the Dark Forces manifest. 
            foreach ($match in $matches) {
                $DF_Match=$match.Groups[1].Value+"\steamapps\appmanifest_32400.acf" 
        
                # If we find the drive - we are good to go. 
                if (Test-Path  $DF_Match) {
                    $STEAMINSTALL=$match.Groups[1].Value+"\steamapps\common\Dark Forces"
                    debug("Found STEAMINSTALL in the VCF library in path [$STEAMINSTALL] ")
                    break
                }
            }
        }
    }
}

debug("Checking if [$STEAMINSTALL] exists...")

# Check if Steam Path exists
if (!($TEST_NO_STORE) -and $STEAMINSTALL -and (Test-Path $STEAMINSTALL)) {
    
    debug("Path [$STEAMINSTALL] exists...")

    # It's STEAM !
    $STORE="STEAM"
    $DFINSTALL=$STEAMINSTALL
    $DOSBOXCONFPATH=$DFINSTALL+"\dosbox.conf"
    $GAMEPATH=$DFINSTALL+"\GAME"
} else {
    
    debug("Path [$STEAMINSTALL] does not exist...")
    debug("Now checking if this is GOG...")

    #Check if GOG
    try {
        #PS 2.0 hack
        $ErrorActionPreference = "stop"
        $GOGINSTALL=(Get-ItemProperty -Path HKLM:\\Software\Wow6432Node\GOG.com\Games\1421404433 -Name path).path
    } catch {
        $ErrorActionPreference = "continue"
        debug("GOG is not in the Registry")
    }
    debug("GOGINSTALL is [$GOGINSTALL]")

    if (!($TEST_NO_STORE) -and $GOGINSTALL -and (Test-Path $GOGINSTALL) )  {
        debug("$GOGINSTALL exists!")

        # It's GOG! 
        $STORE="GOG"
        $DFINSTALL=$GOGINSTALL
        $DOSBOXCONFPATH=$DFINSTALL+"\dosbox_DF_single.conf"
        $GAMEPATH=$DFINSTALL
    }
        
    else {
        
        debug("GOGINSTALL does NOT exist!")

        $EAINSTALL=(Get-ItemProperty -Path "HKLM:\\Software\WOW6432Node\LucasArts\STAR WARS Dark Forces" -Name "Install Dir")."Install Dir"
        if (!($TEST_NO_STORE) -and $EAINSTALL -and (Test-Path $EAINSTALL) )  {
            debug("$EAINSTALL exists!")

            # It's EA! 
            $STORE="EA"
            $DFINSTALL=$EAINSTALL+"\DosBox"
            $DOSBOXCONFPATH=$DFINSTALL+"\Dosbox.conf"
            $GAMEPATH=$DFINSTALL+"\GAME"
        }

        else {

            # Check current folder
            $DFINSTALL=(get-location).path

            try {
                $ErrorActionPreference = "stop"
                # Look for DARK.EXE 
                if ((Test-Path $DFINSTALL) -and (Test-Path "$DFINSTALL\DARK.EXE")) {
                
                    $STORE="STANDALONE"
                    $GAMEPATH=$DFINSTALL
                    $DOSBOXEXE="$DFINSTALL\dosbox\dosbox.exe"

                    # Find dosbox.exe
                    if (!(Test-Path $DOSBOXEXE)) {
                        Replace-Dosbox $DFINSTALL
                    }

                    # Find dosbox config
                    if (Test-Path "$DFINSTALL\dosbox.conf") {
                        $DOSBOXCONFPATH="$DFINSTALL\dosbox.conf"
                    }
                    elseif (Test-Path "$DFINSTALL\dosbox_DF_single.conf") {
                        $DOSBOXCONFPATH="$DFINSTALL\dosbox_DF_single.conf"
                    }
                    else {
                        download $DOSBOX_GOG_CONF "$DFINSTALL\dosbox_DF_single.conf" 
                        $DOSBOXCONFPATH="$DFINSTALL\dosbox_DF_single.conf"
                    }

                    # In case this is a GOG standalone
                    if (Test-Path "$DFINSTALL\dosbox_DF.conf") {
                        $STANDALONECONF=' -conf "'+$DFINSTALL+'\dosbox_DF.conf"'
                    }
                }
                else { 
                    throw "Missing DARK.EXE"
                }
             }

            # Did not find in current folder - prompt user
            catch {
                $ErrorActionPreference = "continue"
                # Preserve previous messages for debugging

                $done = $False  
                $getdosbox = $False             
                
                do {
                    Write-Host ""
                    Write-Host "Failed To find Dark Forces! Press Any Key to Continue..." -NoNewLine
                    $UserInput = $Host.UI.ReadLine()
                    if (!($global:DEBUG)) {Clear-Host}  

                    Write-Host "============================ WARNING ============================" -ForegroundColor Red -BackgroundColor Black
                    Write-Host "             The Script cannot find Dark Forces !!               " -BackgroundColor Black 
                    Write-Host "                                                                 " -BackgroundColor Black
                    Write-Host " "$YELLOW"Either place DarkForcesLauncher.ps1 in the same folder         " -BackgroundColor Black
                    Write-Host " "$YELLOW"      as DARK.EXE or provide the path below                    " -BackgroundColor Black
                    Write-Host "                                                                 " -BackgroundColor Black
                    Write-Host " You must provide the Dark Forces folder that contains...        " -BackgroundColor Black
                    Write-Host " 1. "$YELLOW"DARK.EXE                                                    " -BackgroundColor Black
                    Write-Host " 2. "$YELLOW"DOSBOX.CONF$WHITE or "$YELLOW"DOSBOX_DF_SINGLE.CONF                        " -BackgroundColor Black
                    Write-Host " 3. "$YELLOW"DOSBOX\dosboxe.exe                                          " -BackgroundColor Black
                    Write-Host "                                                                 " -BackgroundColor Black
                    Write-Host "                                                                 " -BackgroundColor Black
                    Write-Host "               Press"$ORANGE"D$WHITE to Download DosBox"$GREEN" (Recommended)          " -BackgroundColor Black
                    Write-Host "                      Press"$ORANGE"Q$WHITE to Exit                            " -BackgroundColor Black              
                    Write-Host "                                                                 " -BackgroundColor Black
                    Write-Host "============================ WARNING ============================" -ForegroundColor Red -BackgroundColor Black
                    Write-Host ""
                    Write-Color "Previously tried looking in Folder [ ",$DFINSTALL," ]" -Color Cyan,green,Cyan
                    Write-Host ""

                    $DFINSTALL = Read-Host "Type Q, D or Path to Dark Forces executable (DARK.EXE) (Ex: C:\Dark Forces)"
                    Write-Host ""
     
                    
                    if ($DFINSTALL) {

                        # Exit
                        if ($DFINSTALL.tolower() -eq 'q') {
                            exit
                        } 
                        # Exit
                        if ($DFINSTALL.tolower() -eq 'd') {
                            Write-Color "Will Download Dosbox Automatically! Type the Path again!" -Color Green
                            Write-Host ""
                            $DFINSTALL = Read-Host "Type the Path to Dark Forces executable (DARK.EXE) (Ex: C:\Dark Forces)"
                            $getdosbox=$True
                        }                        

                        # Look for DARK.EXE 
                        if ((Test-Path $DFINSTALL) -and (Test-Path "$DFINSTALL\DARK.EXE")) {
                
                            $STORE="STANDALONE"
                            $GAMEPATH=$DFINSTALL
                            $DOSBOXEXE="$DFINSTALL\dosbox\dosbox.exe"

                            Write-Color "Found DARK.EXE in path [ ",$DFINSTALL\DARK.EXE," ]" -Color Cyan,Green,Cyan 
                            
                            if ($getdosbox) {
                                Replace-Dosbox $DFINSTALL
                            } 

                            # Find dosbox.exe
                            if (!(Test-Path $DOSBOXEXE)) {
                                Write-Color "Missing DOSBOX.EXE in Path [","$DOSBOXEXE"," ]" -Color Cyan,Red,Cyan                                
                                continue
                            } else {
                               Write-Color "Found DOSBOX.EXE in Path [","$DOSBOXEXE"," ]" -Color Cyan,Green,Cyan                                
                            }

                            # Find dosbox config
                            if (Test-Path "$DFINSTALL\dosbox.conf") {
                                $DOSBOXCONFPATH="$DFINSTALL\dosbox.conf"
                                Write-Color "Found DOSBOX.CONF in Path [ ","$DFINSTALL\dosbox.conf"," ]" -Color Cyan,Green,Cyan                                
                            }
                            elseif (Test-Path "$DFINSTALL\dosbox_DF_single.conf") {
                                $DOSBOXCONFPATH="$DFINSTALL\dosbox_DF_single.conf"
                                Write-Color "Found DOSBOX_DF_SINGLE.CONF in Path [ ","$DFINSTALL\DOSBOX_DF_SINGLE.CONF"," ]" -Color Cyan,Green,Cyan                                
                            }
                            else {
                                Write-Color "Missing DOSBOX.CONF or DOSBOX_DF_SINGLE.CONF in Path [ ","$DFINSTALL"," ]" -Color Cyan,Red,Cyan                                
                                continue
                            }

                            # In case this is a GOG standalone
                            if (Test-Path "$DFINSTALL\dosbox_DF.conf") {
                                $STANDALONECONF=' -conf "'+$DFINSTALL+'\dosbox_DF.conf"'
                            }
                            $done = $true
                        }
                        else {
                            Write-Color "Missing DARK.EXE in Path [ ",$DFINSTALL," ]" -Color Cyan,Red,Cyan                                
                        }
                    }
                }
                until ($done)

            }   
        } 
    } 
}

# Check if this is the first time you are running
function FirstTimeLaunch 
{

    $filefirst = $GAMEPATH + "\df_launcher.cfg"

    # If file does not exist it means you haven't run this before
    $firsttime = (Test-Path $filefirst)


    if (!($firsttime)) {
  
      debug ("Running Launcher for the first itme. Will write to "+$GAMEPATH)

      # TLDR Skip
      $done = $False
      $automate = $False

      do {
        debug("Checking if you want to auto skip setup...")

        Clear-Host 
        Write-Color -Text ("="*55) -Color White
        Write-Color -Text "   First Time Setup. What would you like to do?" -Color Yellow
        Write-Color -Text ("="*55) -Color White
        Write-Host ""
        Write-Color -Text "    1:  ","TLDR: Automate All Setup (","Recommended",")" -Color  Red,Cyan,Yellow,Cyan
        Write-Color -Text "    2:  ","Choose Best Settings yourself" -Color Red,Cyan
        Write-Host ""
        $prompt = Read-Host "            Choose (1 or 2)"

        if (!($prompt.Equals(''))) {

            if (($prompt.ToLower() -eq '1') -or ( $prompt.ToLower() -eq 'tldr')) {
                $done = $True
                $automate = $True

            }

            if (($prompt.ToLower() -eq '2') -or ( $prompt.ToLower() -eq 'choose')) {
                $done = $True
            }
        }
    
      }

      until ($done)
      
      Write-Host ""
      Write-Host ""

      # MOUSELOOK
      $done = $False

      if ($automate) {
        RunMouseConfig
        Write-Color -Text "Running Launcher for the first time! Setting up Mouselook..." -Color Yellow
      } 
      else {
          do {
            debug("Prompting user to install Mouselook...")

            Clear-Host 
            Write-Color -Text "Would you like to setup Modern Mouselook? ( ", "HIGHLY Recommended"," )" -Color Yellow, Green,Yellow
            $prompt = Read-Host "(Y)es / (N)o" 

        
            if (!($prompt.Equals(''))) {

                if (($prompt.ToLower() -eq 'y') -or ( $prompt.ToLower() -eq 'yes')) {
                    $done = $True
                    RunMouseConfig
                    Write-Color -Text "Running Launcher for the first time! Setting up Mouselook..." -Color Yellow
                    start-Sleep -s 3
                    Read-Host "Press Any Key to Continue..."

                }

                if (($prompt.ToLower() -eq 'n') -or ( $prompt.ToLower() -eq 'no')) {
                    $done = $True
                }
            }
    
          } 
          until ($done)
      }


  
      
      # PATCH
      $done = $False

      if ($automate) {
        PatchDarkForces $TRUE
      } 
      else {
          do {
            debug("Prompting user to install the patch...")

            Clear-Host 
            Write-Color -Text "Would you like to install the Dark Forces Community Patch? ( ","Recommended"," )" -Color Yellow,Green,Yellow
            $prompt = Read-Host "(Y)es / (N)o" 


        
            if (!($prompt.Equals(''))) {

                if (($prompt.ToLower() -eq 'y') -or ( $prompt.ToLower() -eq 'yes')) {
                    $done = $True
                    PatchDarkForces

                }

                if (($prompt.ToLower() -eq 'n') -or ( $prompt.ToLower() -eq 'no')) {
                    $done = $True
                }
            }
    
          } 
          until ($done)
      }

      
      # WINDOW
      $done = $False

      if ($automate) {
            FullScreen $false
            Set-RecommendedResolution 
      }
      else {
          do {
            debug("Prompting user to Setup Window...")

            Clear-Host 
            Write-Color -Text "Last Step! Are you a Streamer? Would you like to change ","Window Size"," for streaming in OBS?" -Color Yellow,Green,Yellow
            $prompt = Read-Host "(Y)es / (N)o" 

            if (!($prompt.Equals(''))) {
                if (($prompt.ToLower() -eq 'y') -or ( $prompt.ToLower() -eq 'yes')) {
                    $done = $True
                    Change-Resolution
                }

                if (($prompt.ToLower() -eq 'n') -or ( $prompt.ToLower() -eq 'no')) {
                    $done = $True
                }
             }
          } 
          until ($done)
       }

       # Mark as configured
       Out-File -FilePath $filefirst
    }
}

# Quick & Dirty check if patched - check file size of DARK.GOB
function IsPatched 
{
   $global:ISPATCHED = $FALSE
   $DARKPATH=$GamePath+'\DARK.GOB'
   If ((Test-Path $DARKPATH) -and ((Get-Item $DARKPATH).length -ne $DARKGOBSIZE))  {
        $global:ISPATCHED = $TRUE
   } 
}
 
# Load the mission Files 
Load-MissionFiles

# Load the DosBox configuration
Load-DosBoxConfigFile

# Check if Patched
IsPatched

# Display the DF Path Info
if ($global:DEBUG) { Show-GameInfo }

# Check First Time
FirstTimeLaunch

function prompt  
{  
    $ESC = [char]27
    "$ESC[46mPS $($executionContext.SessionState.Path.CurrentLocation)$('>' * ($nestedPromptLevel + 1)) $ESC[0m"  
}

prompt

# Game Outer Loop
do { 

    # Show the DF Launcher Menu Loop
    do {
        
        function Show-Menu
        {
            param ([string]$Title = 'Dark Forces Maps')
    
            debug("Inside the Main Menu")
            # Force override this message if there is no executable
            if ($global:NOEXECUTABLE) {
               $global:LASTMESSAGE="Important! Missing $DF_EXECUTABLE in $DOSBOXCONFPATH. `r`nGo to Help Menu (H) and press (U) to Update Dosbox.conf"
            }
           
            if (!($global:DEBUG)) {Clear-Host}
            Write-Color -Text ("="*29)," INFO ",("="*29) -Color White,Yellow,White -BlackConsole $True
            Write-Color "#                                                              #" -Color White -BlackConsole $True
            Write-Color "#  Welcome to Karjala's Dark Forces Launcher.                  #" -Color White -BlackConsole $True
            Write-Color "#                                                              #" -Color White -BlackConsole $True         
            Write-Color "#  If you just want to play ","Dark Forces", " simply press [","D","]       #" -Color White,Red,White,Red,White -BackgroundColor Black,Black,Black,Black,Black -BlackConsole $True   
            Write-Color "#  If you want to play a ","Custom Mission"," press [","C","]              #" -Color White,Cyan,White,Cyan,White  -BackgroundColor Black,Black,Black,Black,Black  -BlackConsole $True   
            Write-Color "#                                                              #"  -Color White -BlackConsole $True   
            Write-Color "#  To setup up ","MouseLook"," or Key Rebinds press [","M","]              #" -Color White,Green,White,Green,White -BackgroundColor Black,Black,Black,Black,Black  -BlackConsole $True   
            Write-Color "#  To get ","Help"," and display game settings press [","H","]             #"  -Color White,Yellow,White,Yellow,White -BackgroundColor Black,Black,Black,Black,Black  -BlackConsole $True   
            Write-Color "#                                                              #" -Color White -BlackConsole $True   
            Write-Color "#                                                              #" -Color White -BlackConsole $True   
            Write-Color "#   Enjoy!                                                     #" -Color White -BlackConsole $True   
            Write-Color "#                                                              #" -Color White -BlackConsole $True   
            Write-Color "#                                                              #" -Color White -BlackConsole $True   
            Write-Color ("="*25)," Game Options ",("="*25) -Color White,Yellow,White -BlackConsole $True   
            Write-Host
            if ($global:LASTMESSAGE) {
                Write-Host "$global:LASTMESSAGE" -ForegroundColor "Yellow"
            }
            Write-Host
            Write-Host "Please choose an option from below:" 
            Write-Host "D: Press 'D' to play Dark Forces" -ForegroundColor "Red"
            Write-Host "C: Press 'C' to play Custom Dark Forces Missions" -ForegroundColor "Cyan"
            Write-Host $BEIGE"F: Press 'F' to play the game in Full Screen (default)"
            Write-Host "W: Press 'W' to play the game in a Window (Streamers Pick This!)" -ForegroundColor "Magenta"
            Write-Host "H: Press 'H' to show the Help Menu. (Pick this if you are stuck)" -ForegroundColor "Yellow"            
            Write-Host "M: Press 'M' to configure Mouselook, Key Remaps and Crosshair" -ForegroundColor "Green"
            Write-Host "K: Press 'K' to get help on Discord"  -ForegroundColor "DarkYellow"
            Write-Host $ORANGE"Y: Press 'Y' for the Dark Forces Walkthrough" -ForegroundColor "Red"
            Write-Host "S: Press 'S' for the Streaming Tutorial" -ForegroundColor "Magenta"
            Write-Host "T: Press 'T' for the Launcher Tutorial" -ForegroundColor "DarkCyan"
            Write-Host "P: Press 'P' to install Dark Forces Commnunity Patch" -ForegroundColor "Cyan"
            Write-Host $LIME"A: Press 'A' for Acknowldgements" -ForegroundColor "DarkGreen"
            Write-Host $PURPLE"Q: Press 'Q' to Quit."  -ForegroundColor "DarkGray"

        }
          
        Show-Menu
        Write-Host ("-"*64)
        Write-Host
        $selection = (Read-Host "Please make a Selection and press"$ORANGE"Enter"$WHITE).ToLower()
        
        # Reset LASTMESSAGE
        $global:LASTMESSAGE=""
        
        debug("You've chosen option [$selection]")

        switch($selection)
        {
            # Run Dark Forces by itself
            'd' { RunDarkForces }

            # Choose a custom mission and Run it
            'c' { SelectCustomMap }

            # Run Mouse and Key rebind configuration utility
            'm' { RunMouseConfig }
             
            # Show Help Menu 
            'h' { Help }

            # Go full screen
            'f' { FullScreen }

            # Go to Discord 
            'k' { StartProcessWrapper $DISCORDPATH }

            # Custom Resolution
            'w' { Change-Resolution $false }

            # Show Acknowledgements
            'a' { Acknowledgements $false }

            # Patch Dark Forces
            'p' { PatchDarkForces }

            # Youtube Dark Forces Walkthrough
            'y' { StartProcessWrapper $DFWALKTHROUGH }

            # Youtube Launcher Walkthrough
            't' { StartProcessWrapper $LAUNCHERTUTORIAL }

            # Streaming Tutorial
            's' { StartProcessWrapper $STREAMTUTORIAL } 

            # Exit the Launcher
            'q' {exit}
        }
    }

    # Keep checking until you quit
    until ($selection -eq 'd')
}
# Run Forever until player chooses to Quit.
until ($false)
 
